# How to build

## Pre-requisites

```
sudo apt install python3-build \
 libpython3-dev libldap-dev libsasl2-dev
```

## Build python sdist and bdist

```
python3 -m build
```

## Build Debian package

First update `debian/changelog`:

```
dch -i
```

Then:

```
dpkg-builpackage
```

## Run locally for debugging

Let's create a virtualenv. We use option `--system-site-packages` to
avoid the to install dependencies that are already available on our
system.

```
python3 -m venv --system-site-packages venv
./venv/bin/python -m pip install -e .
./venv/bin/python -m postquota -h
```

Then you can simulate communications coming from postfix:

```
printf "request=...\nqueue_id=ABC42DEF42\nsasl_username=test_ee\n\n" | nc -q 0 localhost 9001
```

And you can query the Rest API:

```
curl -s http://localhost:9002/?cmd=dump | json_pp
```